/******************************************************************************
 *
 *  sysdata.h -	
 *
 * $Id: sysdata.h 3455 2017-04-24 08:50:31Z scribe $
 * 
 * Copyright 2001-2013 CrossWire Bible Society (http://www.crosswire.org)
 *	CrossWire Bible Society
 *	P. O. Box 2528
 *	Tempe, AZ  85280-2528
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation version 2.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 */

#ifndef SIZEDTYPES_H
#define SIZEDTYPES_H

#include <cstdint>

/*
 * __xx is ok: it doesn't pollute the POSIX namespace. Use these in the
 * header files exported to user space
 */
#ifdef USE_AUTOTOOLS
#include "config.h"
#endif


#undef __swswap16
#undef __swswap32
#undef __swswap64

#define __swswap16(x) \
	((std::uint16_t)( \
		(((std::uint16_t)(x) & (std::uint16_t)0x00ffU) << 8) | \
		(((std::uint16_t)(x) & (std::uint16_t)0xff00U) >> 8) ))

		
#define __swswap32(x) \
	((std::uint32_t)( \
		(((std::uint32_t)(x) & (std::uint32_t)0x000000ffUL) << 24) | \
		(((std::uint32_t)(x) & (std::uint32_t)0x0000ff00UL) <<  8) | \
		(((std::uint32_t)(x) & (std::uint32_t)0x00ff0000UL) >>  8) | \
		(((std::uint32_t)(x) & (std::uint32_t)0xff000000UL) >> 24) ))

		
#define __swswap64(x) \
	((std::uint64_t)( \
		(std::uint64_t)(((std::uint64_t)(x) & (std::uint64_t)0x00000000000000ffULL) << 56) | \
		(std::uint64_t)(((std::uint64_t)(x) & (std::uint64_t)0x000000000000ff00ULL) << 40) | \
		(std::uint64_t)(((std::uint64_t)(x) & (std::uint64_t)0x0000000000ff0000ULL) << 24) | \
		(std::uint64_t)(((std::uint64_t)(x) & (std::uint64_t)0x00000000ff000000ULL) <<  8) | \
		   (std::uint64_t)(((std::uint64_t)(x) & (std::uint64_t)0x000000ff00000000ULL) >>  8) | \
		(std::uint64_t)(((std::uint64_t)(x) & (std::uint64_t)0x0000ff0000000000ULL) >> 24) | \
		(std::uint64_t)(((std::uint64_t)(x) & (std::uint64_t)0x00ff000000000000ULL) >> 40) | \
		(std::uint64_t)(((std::uint64_t)(x) & (std::uint64_t)0xff00000000000000ULL) >> 56) ))
		



#ifndef WORDS_BIGENDIAN

#define swordtoarch16(x) (x)
#define swordtoarch32(x) (x)
#define swordtoarch64(x) (x)
#define archtosword16(x) (x)
#define archtosword32(x) (x)
#define archtosword64(x) (x)

#else 

#define swordtoarch16(x) __swswap16(x)
#define swordtoarch32(x) __swswap32(x)
#define swordtoarch64(x) __swswap64(x)
#define archtosword16(x) __swswap16(x)
#define archtosword32(x) __swswap32(x)
#define archtosword64(x) __swswap64(x)


#endif


#endif
